package com.yuandian.dataflow.statemachine;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.concurrent.CompletableFuture;

import org.apache.ratis.protocol.Message;
import org.apache.ratis.protocol.RaftClientReply;
import org.apache.ratis.protocol.RaftPeer;

public class StateServerFactory {
    public static StateServer stateServer;

    public static void startServer(String sid) throws IOException, InterruptedException {
 
        var peers = new ArrayList<RaftPeer>();
        String[] addresses = new String[]{"localhost:4440","localhost:4441","localhost:4442"};
    
        for (int i = 0; i < addresses.length; i++) {
          var port = addresses[i].split(":")[1]; 
          peers.add(RaftPeer.newBuilder().setId("yd-" + port).setAddress(addresses[i]).build());
        }
    
        //find current peer object based on application parameter
        // final RaftPeer currentPeer = peers.get(Integer.parseInt(sid));
    
        //start a counter server
 
        final StateServer stateServer = new StateServer(peers.get(Integer.parseInt(sid)), peers);
 
        stateServer.start();
        stateServer.close();
    }


    public static PeerId CurrentPeerId() {
        return stateServer.getPeer();
    }

    public static RaftClientReply send(Message msg) throws IOException {
        return stateServer.getRaftClient().io().send(msg);
    }

    public static CompletableFuture<RaftClientReply>  asyncSend(Message msg) throws IOException {

        return stateServer.getRaftClient().async().send(msg);
    }
}
